/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id$
 */
/*
 * ǥХ쥸at91sam7s.h֡
 */

#ifndef TOPPERS_TARGET_AT91SAM7S_H
#define TOPPERS_TARGET_AT91SAM7S_H

#include "at91sam7s.h"

/*
 *  PARALLEL INPUT/OUTPUT CONTROLLER
 */
#define AT91S_PIO_PA2      (1<<2)		/* Pin Controlled by PA2 */
#define AT91S_PIO_PA3      (1<<3)		/* Pin Controlled by PA3 */
#define AT91S_PIO_PA4      (1<<4)		/* Pin Controlled by PA4 */
#define AT91S_PIO_PA5      (1<<5)		/* Pin Controlled by PA5 */
#define AT91S_PIO_PA6      (1<<6)		/* Pin Controlled by PA6 */
#define AT91S_PIO_PA7      (1<<7)		/* Pin Controlled by PA7 */
#define AT91S_PIO_PA10     (1<<10)	/* Pin Controlled by PA10 */
#define AT91S_PIO_PA11     (1<<11)	/* Pin Controlled by PA11 */
#define AT91S_PIO_PA12     (1<<12)	/* Pin Controlled by PA12 */
#define AT91S_PIO_PA13     (1<<13)	/* Pin Controlled by PA13 */
#define AT91S_PIO_PA14     (1<<14)	/* Pin Controlled by PA14 */
#define AT91S_PIO_PA17     (1<<17)	/* Pin Controlled by PA17 */
#define AT91S_PIO_PA18     (1<<18)	/* Pin Controlled by PA18 */
#define AT91S_PIO_PA19     (1<<19)	/* Pin Controlled by PA19 */
#define AT91S_PIO_PA20     (1<<20)	/* Pin Controlled by PA20 */
#define AT91S_PIO_PA21     (1<<21)	/* Pin Controlled by PA21 */
#define AT91S_PIO_PA22     (1<<22)	/* Pin Controlled by PA22 */
#define AT91S_PIO_PA23     (1<<23)	/* Pin Controlled by PA23 */
#define AT91S_PIO_PA24     (1<<24)	/* Pin Controlled by PA24 */
#define AT91S_PIO_PA25     (1<<25)	/* Pin Controlled by PA25 */
#define AT91S_PIO_PA27     (1<<27)	/* Pin Controlled by PA27 */
#define AT91S_PIO_PA28     (1<<28)	/* Pin Controlled by PA28 */
#define AT91S_PIO_PA29     (1<<29)	/* Pin Controlled by PA29 */
#define AT91S_PIO_PA30     (1<<30)	/* Pin Controlled by PA30 */
#define AT91S_PIO_PA31     (1<<31)	/* Pin Controlled by PA31 */

/*
 * TWO-WIRE INTERFACE (TWI)
 */
//#define TOFF_TWI_CR      0x0000			/* Control Register (W) */
  #define AT91S_TWI_START       (1<<0)	/* (TWI) Send a START Condition */
  #define AT91S_TWI_STOP        (1<<1)	/* (TWI) Send a STOP Condition */
  #define AT91S_TWI_MSEN        (1<<2)	/* (TWI) TWI Master Transfer Enabled */
//#define TOFF_TWI_SR      0x0020			/* Status Register (R) */
  #define AT91S_TWI_RXRDY       (1<<1)	/* (TWI) Receive holding register ReaDY */
  #define AT91S_TWI_TXRDY       (1<<2)	/* (TWI) Transmit holding register ReaDY */
  #define AT91C_TWI_OVRE        (1<<6)	/* (TWI) Overrun Error */
  #define AT91C_TWI_UNRE        (1<<7)	/* (TWI) Underrun Error */
  #define AT91S_TWI_NACK        (1<<8)	/* (TWI) Not Acknowledged */

/*
 *  SYNCHRONOUS SERIAL CONTROLLER (SSC)
 */
//#define TOFF_SSC_CR      0x0000			/* Control Register (W) */
  #define SSC_RXEN              (1<<0)	/* (SSC) Receive Enable */
  #define SSC_RXDIS             (1<<1)	/* (SSC) Receive Disable */
  #define SSC_TXEN              (1<<8)	/* (SSC) Transmit Enable */
  #define SSC_TXDIS             (1<<9)	/* (SSC) Transmit Disable */
  #define SSC_SWRST             (1<<15)	/* (SSC) Software Reset */
//#define TOFF_SSC_RCMR    0x0010			/* Receive Clock Mode Register (R/W) */
  #define SSC_CKS_DIV           (0<<0)	/* (SSC) Divided Clock */
  #define SSC_CKS_TK            (1<<0)	/* (SSC) TK Clock signal */
  #define SSC_CKS_RK            (2<<0)	/* (SSC) RK pin */
  #define SSC_CKO_NONE          (0<<2)	/* (SSC) Receive/Transmit Clock Output Mode: None RK pin: Input-only */
  #define SSC_CKO_CONTINOUS     (1<<2)	/* (SSC) Continuous Receive/Transmit Clock RK pin: Output */
  #define SSC_CKO_DATA_TX       (2<<2)	/* (SSC) Receive/Transmit Clock only during data transfers RK pin: Output */
  #define SSC_START_CONTINOUS   (0<<8)	/* (SSC) Continuous, as soon as the receiver is enabled, and immediately after the end of transfer of the previous data. */
  #define SSC_START_TX          (1<<8)	/* (SSC) Transmit/Receive start */
  #define SSC_START_LOW_RF      (2<<8)	/* (SSC) Detection of a low level on RF input */
  #define SSC_START_HIGH_RF     (3<<8)	/* (SSC) Detection of a high level on RF input */
  #define SSC_START_FALL_RF     (4<<8)	/* (SSC) Detection of a falling edge on RF input */
  #define SSC_START_RISE_RF     (5<<8)	/* (SSC) Detection of a rising edge on RF input */
  #define SSC_START_LEVEL_RF    (6<<8)	/* (SSC) Detection of any level change on RF input */
  #define SSC_START_EDGE_RF     (7<<8)	/* (SSC) Detection of any edge on RF input */
  #define SSC_START_0           (8<<8)	/* (SSC) Compare 0 */
//#define TOFF_SSC_RFMR    0x0014			/* Receive Frame Mode Register (R/W) */
  #define SSC_LOOP              (1<<5)	/* (SSC) Loop Mode */
  #define SSC_MSBF              (1<<7)	/* (SSC) Most Significant Bit First */
//#define TOFF_SSC_SR      0x0040			/* Status Register (R) */
  #define SSC_TXRDY             (1<<0)	/* (SSC) Transmit Ready */
  #define SSC_TXEMPTY           (1<<1)	/* (SSC) Transmit Empty */
  #define SSC_ENDTX             (1<<2)	/* (SSC) End Of Transmission */
  #define SSC_TXBUFE            (1<<3)	/* (SSC) Transmit Buffer Empty */
  #define SSC_RXRDY             (1<<4)	/* (SSC) Receive Ready */
  #define SSC_OVRUN             (1<<5)	/* (SSC) Receive Overrun */
  #define SSC_ENDRX             (1<<6)	/* (SSC) End of Reception */
  #define SSC_RXBUFF            (1<<7)	/* (SSC) Receive Buffer Full */
  #define SSC_CP0               (1<<8)	/* (SSC) Compare 0 */
  #define SSC_CP1               (1<<9)	/* (SSC) Compare 1 */
  #define SSC_TXSYN             (1<<10)	/* (SSC) Transmit Sync */
  #define SSC_RXSYN             (1<<11)	/* (SSC) Receive Sync */
  #define SSC_TXENA             (1<<16)	/* (SSC) Transmit Enable */
  #define SSC_RXENA             (1<<17)	/* (SSC) Receive Enable */
#define TOFF_SSC_RPR     0x0100			/* (PDC_SSC) Receive Pointer Register */
#define TOFF_SSC_RCR     0x0104			/* (PDC_SSC) Receive Counter Register */
#define TOFF_SSC_TPR     0x0108			/* (PDC_SSC) Transmit Pointer Register */
#define TOFF_SSC_TCR     0x010C			/* (PDC_SSC) Transmit Counter Register */
#define TOFF_SSC_RNPR    0x0110			/* (PDC_SSC) Receive Next Pointer Register */
#define TOFF_SSC_RNCR    0x0114			/* (PDC_SSC) Receive Next Counter Register */
#define TOFF_SSC_TNPR    0x0118			/* (PDC_SSC) Transmit Next Pointer Register */
#define TOFF_SSC_TNCR    0x011C			/* (PDC_SSC) Transmit Next Counter Register */
#define TOFF_SSC_PTCR    0x0120			/* (PDC_SSC) PDC Transfer Control Register */
  #define PDC_RXTEN             (1<<0)	/* (PDC) Receiver Transfer Enable */
  #define PDC_RXTDIS            (1<<1)	/* (PDC) Receiver Transfer Disable */
  #define PDC_TXTEN             (1<<8)	/* (PDC) Transmitter Transfer Enable */
  #define PDC_TXTDIS            (1<<9)	/* (PDC) Transmitter Transfer Disable */
#define TOFF_SSC_PTSR    0x0124			/* (PDC_SSC) PDC Transfer Status Register */

/*
 *  SERIAL PERIPHERAL INTERFACE (SPI)
 */
#define TOFF_SPI_RPR     0x0100			/* (PDC_SPI) Receive Pointer Register */ 
#define TOFF_SPI_RCR     0x0104			/* (PDC_SPI) Receive Counter Register */
#define TOFF_SPI_TPR     0x0108			/* (PDC_SPI) Transmit Pointer Register */
#define TOFF_SPI_TCR     0x010C			/* (PDC_SPI) Transmit Counter Register */
#define TOFF_SPI_RNPR    0x0110			/* (PDC_SPI) Receive Next Pointer Register */
#define TOFF_SPI_RNCR    0x0114			/* (PDC_SPI) Receive Next Counter Register */
#define TOFF_SPI_TNPR    0x0118			/* (PDC_SPI) Transmit Next Pointer Register */
#define TOFF_SPI_TNCR    0x011C			/* (PDC_SPI) Transmit Next Counter Register */
#define TOFF_SPI_PTCR    0x0120			/* (PDC_SPI) PDC Transfer Control Register */
#define TOFF_SPI_PTSR    0x0124			/* (PDC_SPI) PDC Transfer Status Register */

// -------- SPI_CR : (SPI Offset: 0x0) SPI Control Register -------- 
#define SPI_SPIEN       ((unsigned int) 0x1 <<  0)	// (SPI) SPI Enable
#define SPI_SPIDIS      ((unsigned int) 0x1 <<  1)	// (SPI) SPI Disable
#define SPI_SWRST       ((unsigned int) 0x1 <<  7)	// (SPI) SPI Software reset
#define SPI_LASTXFER    ((unsigned int) 0x1 << 24)	// (SPI) SPI Last Transfer
// -------- SPI_MR : (SPI Offset: 0x4) SPI Mode Register -------- 
#define SPI_MSTR        ((unsigned int) 0x1 <<  0)	// (SPI) Master/Slave Mode
#define SPI_PS          ((unsigned int) 0x1 <<  1)	// (SPI) Peripheral Select
#define SPI_PS_FIXED    ((unsigned int) 0x0 <<  1)	// (SPI) Fixed Peripheral Select
#define SPI_PS_VARIABLE ((unsigned int) 0x1 <<  1)	// (SPI) Variable Peripheral Select
#define SPI_PCSDEC      ((unsigned int) 0x1 <<  2)	// (SPI) Chip Select Decode
#define SPI_FDIV        ((unsigned int) 0x1 <<  3)	// (SPI) Clock Selection
#define SPI_MODFDIS     ((unsigned int) 0x1 <<  4)	// (SPI) Mode Fault Detection
#define SPI_LLB         ((unsigned int) 0x1 <<  7)	// (SPI) Clock Selection
#define SPI_PCS         ((unsigned int) 0xF << 16)	// (SPI) Peripheral Chip Select
#define SPI_DLYBCS      ((unsigned int) 0xFF << 24)	// (SPI) Delay Between Chip Selects
// -------- SPI_RDR : (SPI Offset: 0x8) Receive Data Register -------- 
#define SPI_RD          ((unsigned int) 0xFFFF <<  0)	// (SPI) Receive Data
#define SPI_RPCS        ((unsigned int) 0xF << 16)	// (SPI) Peripheral Chip Select Status
// -------- SPI_TDR : (SPI Offset: 0xc) Transmit Data Register -------- 
#define SPI_TD          ((unsigned int) 0xFFFF <<  0)	// (SPI) Transmit Data
#define SPI_TPCS        ((unsigned int) 0xF << 16)	// (SPI) Peripheral Chip Select Status
// -------- SPI_SR : (SPI Offset: 0x10) Status Register -------- 
#define SPI_RDRF        ((unsigned int) 0x1 <<  0)	// (SPI) Receive Data Register Full
#define SPI_TDRE        ((unsigned int) 0x1 <<  1)	// (SPI) Transmit Data Register Empty
#define SPI_MODF        ((unsigned int) 0x1 <<  2)	// (SPI) Mode Fault Error
#define SPI_OVRES       ((unsigned int) 0x1 <<  3)	// (SPI) Overrun Error Status
#define SPI_ENDRX       ((unsigned int) 0x1 <<  4)	// (SPI) End of Receiver Transfer
#define SPI_ENDTX       ((unsigned int) 0x1 <<  5)	// (SPI) End of Receiver Transfer
#define SPI_RXBUFF      ((unsigned int) 0x1 <<  6)	// (SPI) RXBUFF Interrupt
#define SPI_TXBUFE      ((unsigned int) 0x1 <<  7)	// (SPI) TXBUFE Interrupt
#define SPI_NSSR        ((unsigned int) 0x1 <<  8)	// (SPI) NSSR Interrupt
#define SPI_TXEMPTY     ((unsigned int) 0x1 <<  9)	// (SPI) TXEMPTY Interrupt
#define SPI_SPIENS      ((unsigned int) 0x1 << 16)	// (SPI) Enable Status
// -------- SPI_IER : (SPI Offset: 0x14) Interrupt Enable Register -------- 
// -------- SPI_IDR : (SPI Offset: 0x18) Interrupt Disable Register -------- 
// -------- SPI_IMR : (SPI Offset: 0x1c) Interrupt Mask Register -------- 
// -------- SPI_CSR : (SPI Offset: 0x30) Chip Select Register -------- 
#define SPI_CPOL        ((unsigned int) 0x1 <<  0)	// (SPI) Clock Polarity
#define SPI_NCPHA       ((unsigned int) 0x1 <<  1)	// (SPI) Clock Phase
#define SPI_CSAAT       ((unsigned int) 0x1 <<  2)	// (SPI) Chip Select Active After Transfer
#define SPI_BITS        ((unsigned int) 0xF <<  4)	// (SPI) Bits Per Transfer
#define SPI_BITS_8      ((unsigned int) 0x0 <<  4)	// (SPI) 8 Bits Per transfer
#define SPI_BITS_9      ((unsigned int) 0x1 <<  4)	// (SPI) 9 Bits Per transfer
#define SPI_BITS_10     ((unsigned int) 0x2 <<  4)	// (SPI) 10 Bits Per transfer
#define SPI_BITS_11     ((unsigned int) 0x3 <<  4)	// (SPI) 11 Bits Per transfer
#define SPI_BITS_12     ((unsigned int) 0x4 <<  4)	// (SPI) 12 Bits Per transfer
#define SPI_BITS_13     ((unsigned int) 0x5 <<  4)	// (SPI) 13 Bits Per transfer
#define SPI_BITS_14     ((unsigned int) 0x6 <<  4)	// (SPI) 14 Bits Per transfer
#define SPI_BITS_15     ((unsigned int) 0x7 <<  4)	// (SPI) 15 Bits Per transfer
#define SPI_BITS_16     ((unsigned int) 0x8 <<  4)	// (SPI) 16 Bits Per transfer
#define SPI_SCBR        ((unsigned int) 0xFF <<  8)	// (SPI) Serial Clock Baud Rate
#define SPI_DLYBS       ((unsigned int) 0xFF << 16)	// (SPI) Serial Clock Baud Rate
#define SPI_DLYBCT      ((unsigned int) 0xFF << 24)	// (SPI) Delay Between Consecutive Transfers

/* Clock */
#define CLOCK_FREQUENCY 48000000
#define CLOCK_RATE      48054850
#define BAUD_RATE       460800

/* USART */
#define US_USMODE_HWHSH (0x2)
#define US_SYNC         (0x1 << 8)
#define US_CLKS_CLOCK   (0x0 << 4)
#define US_OVER         (0x1 << 19)

/* TimerCounter */
#define TC_WAVE (1 << 15)
#define TC_ACPA_SET (1 << 16)
#define TC_ACPC_CLEAR (2 << 18)
#define TC_ASWTRG_SET (1 << 22)

/* A/D Converter */
#define ADC_TRGEN_EN (1)
#define ADC_TRGSEL_TIOA1 (1 << 1)
#define ADC_CH6 (1 << 6)
#define ADC_CH4 (1 << 4)

#endif /* TOPPERS_TARGET_AT91SAM7S_H */

