/*
 * original:lejos-osek/src/nxtvm/platform/nxt/nxt_avr.c rev.1.1.1.1
 * modified history.
 * 05/24/2012: Modifier Takuya Ishikawa
 *           : char -> char
 *           : include string.h
 * 05/23/2011: Modifier Takuya Ishikawa
 * 05/24/2010: Modifier Takuya Ishikawa
 *           : Changed interface name to entry function name with TECS naming rule
 *           : Modified initialize to call link_init
 *           : Modified updateBody to call link_init only when twi is not ok
 *                                 to calculate count by exor.
 *           : Deleted nxt_avr_status
 *           : Modified some variables to component variables
 *           : Modified some constants to component attributes
 *           : Modified data type to ITRON spec.
 * 12/13/2009: Modifider Ryosuke Takeuchi
 *           : Modified nxt_avr_init for ITRON ATT_INI static API.
 *           : Modified nxt_avr_1kHz_update to callback function.
 *           : Modified nxt_avr_input_power function. 2nd argument bit2
 *             into io_to_avr.input_power bit4.
 */
/*
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tAVRBody_template.c => src/tAVRBody.c
 * Τ褦̾, եѹƤ齤ޤ
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * °ޥ #_CAAM_#
 * initializedFlag  bool_t           VAR_initializedFlag
 * ioToAvr          TOAVR            VAR_ioToAvr     
 * ioFromAvr        FROMAVR          VAR_ioFromAvr   
 * dataFromAvr      uint8_t*         VAR_dataFromAvr 
 * dataToAvr        uint8_t*         VAR_dataToAvr   
 * isSend           bool_t           VAR_isSend      
 * linkInitWait     uint8_t          VAR_linkInitWait
 * resetFlag        bool_t           VAR_resetFlag   
 *
 * ƤӸؿ #_TCPF_#
 * call port : cTWI  signature: sTWI context: task
 *   bool_t         cTWI_initialize( );
 *   void           cTWI_startWrite( uint32_t dev_addr, uint32_t int_addr_bytes, uint32_t int_addr, const uint8_t* data, uint32_t nBytes );
 *   void           cTWI_startRead( uint32_t dev_addr, uint32_t int_addr_bytes, uint32_t int_addr, uint8_t* data, uint32_t nBytes );
 *   void           cTWI_pollingUpdate( );
 *   bool_t         cTWI_isBusy( );
 *   bool_t         cTWI_isOk( );
 *   void           cTWI_reset( );
 *
 * #[</PREAMBLE>]# */

#include "tAVRBody_tecsgen.h"
#include "target_at91sam7s.h"
#include <sil.h>
#include <string.h>

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

static char *brainwashString = "\xCC" "Let's samba nxt arm in arm, (c)LEGO System A/S";

Inline void
nxt_avr_start_read(void)
{
    int8_t i;

    for(i = 0; i < 13; i++){
        VAR_dataFromAvr[i] = 0;
    }

    cTWI_startRead(NXT_AVR_ADDRESS, 0, 0, VAR_dataFromAvr, 13);
}

Inline void
nxt_avr_start_send(void)
{
    int8_t i;
    uint8_t checkByte = 0;
    uint8_t *a = VAR_dataToAvr;
    uint8_t *b = (uint8_t *)(&VAR_ioToAvr);

    i = sizeof(VAR_ioToAvr);
    while(i){
        *a = *b;
        checkByte += *b;
        a++;
        b++;
        i--;
    }

    *a = ~checkByte;

    cTWI_startWrite(NXT_AVR_ADDRESS, 0, 0, VAR_dataToAvr, 9);
}

Inline void
nxt_avr_link_init(void)
{
    cTWI_startWrite(NXT_AVR_ADDRESS, 0, 0, (const uint8_t *)brainwashString,
                    strlen(brainwashString));
}

Inline uint16_t
Unpack16(const uint8_t *x)
{
    uint16_t retval;

    retval = (((uint16_t) (x[0])) & 0x00ff) | ((((uint16_t) (x[1])) << 8) & 0xff00);
    return retval;
}

Inline void
nxt_avr_unpack(void)
{
    uint8_t check_sum;
    uint8_t *p;
    uint16_t buttonsVal;
    uint32_t voltageVal;
    int8_t i;

    p = VAR_dataFromAvr;

    for(check_sum = i = 0; i < 13; i++){
        check_sum += *p;
        p++;
    }

    if(check_sum != 0xff){
        return;
    }

    p = VAR_dataFromAvr;

    // Marshall
    for(i = 0; i < NXT_AVR_N_INPUTS; i++){
        VAR_ioFromAvr.adc_value[i] = Unpack16(p);
        p += 2;
    }

    buttonsVal = Unpack16(p);
    p += 2;

    VAR_ioFromAvr.buttons = 0;

    if(buttonsVal > 1023){
        VAR_ioFromAvr.buttons |= 1;
        buttonsVal -= 0x7ff;
    }

    if(buttonsVal > 720){
        VAR_ioFromAvr.buttons |= 0x08;
    } else if(buttonsVal > 270){
        VAR_ioFromAvr.buttons |= 0x04;
    } else if(buttonsVal > 60){
        VAR_ioFromAvr.buttons |= 0x02;
    }

    voltageVal = Unpack16(p);

    VAR_ioFromAvr.battery_is_AA = (voltageVal & 0x8000) ? 1 : 0;
    VAR_ioFromAvr.avr_fw_version_major = (voltageVal >> 13) & 3;
    VAR_ioFromAvr.avr_fw_version_minor = (voltageVal >> 10) & 7;


    // Figure out voltage
    // The units are 13.848 mV per bit.
    // To prevent fp, we substitute 13.848 with 14180/1024

    voltageVal &= 0x3ff;		// Toss unwanted bits.
    voltageVal *= 14180;
    voltageVal >>= 10;
    VAR_ioFromAvr.battery_mV = voltageVal;

}

static inline void
nxt_avr_updateBody(void)
{
    int8_t i;

    if(!VAR_initializedFlag){
        return;
    }

    if(VAR_linkInitWait){
        VAR_linkInitWait--;
        return;
    }

    if(!cTWI_isOk()){
        cTWI_initialize();

        for(i = 0; i < 13; i++){
            VAR_dataFromAvr[i] = 0;
        }

        nxt_avr_link_init();
        VAR_linkInitWait = 2;
        VAR_isSend = false;
        return;
    }

    if(cTWI_isBusy() && !VAR_resetFlag){
        cTWI_initialize();

        for(i = 0; i < 13; i++){
            VAR_dataFromAvr[i] = 0;
        }

        nxt_avr_link_init();
        VAR_linkInitWait = 2;
        VAR_isSend = false;
        return;
    }

    if(VAR_isSend){
        nxt_avr_unpack();
        nxt_avr_start_send();
    } else {
        nxt_avr_start_read();
    }

    VAR_isSend ^= 0x01;
}

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eAvrMotor
 * entry port: eAvrMotor
 * signature:  sAvrMotor
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eAvrMotor_setMotor
 * name:         eAvrMotor_setMotor
 * global_name:  tAVRBody_eAvrMotor_setMotor
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eAvrMotor_setMotor(uint8_t portNumber, int8_t powerPercent, bool_t brake)
{
    if(portNumber < 3){
        VAR_ioToAvr.output_percent[portNumber] = powerPercent;

        if(brake){
            VAR_ioToAvr.output_mode |= (1 << portNumber);
        } else {
            VAR_ioToAvr.output_mode &= ~(1 << portNumber);
        }
    }
}

/* #[<ENTRY_PORT>]# eAvrSensor
 * entry port: eAvrSensor
 * signature:  sAvrSensor
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eAvrSensor_setInputPower
 * name:         eAvrSensor_setInputPower
 * global_name:  tAVRBody_eAvrSensor_setInputPower
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eAvrSensor_setInputPower(uint8_t portNumber, uint8_t powerType)
{
    if(portNumber < 4 && powerType <= 2){
        VAR_ioToAvr.input_power &= ~(0x11 << portNumber);
        VAR_ioToAvr.input_power |= ((powerType & 0x2 ? 0x10 << portNumber : 0) | ((powerType & 1) << portNumber));
    }
}

/* #[<ENTRY_FUNC>]# eAvrSensor_getSensor
 * name:         eAvrSensor_getSensor
 * global_name:  tAVRBody_eAvrSensor_getSensor
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
uint16_t
eAvrSensor_getSensor(uint8_t portNumber)
{
    if(portNumber < 4){
        return VAR_ioFromAvr.adc_value[portNumber];
    } else {
        return 0;
    }
}

/* #[<ENTRY_PORT>]# eAvrButton
 * entry port: eAvrButton
 * signature:  sAvrButton
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eAvrButton_getButton
 * name:         eAvrButton_getButton
 * global_name:  tAVRBody_eAvrButton_getButton
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
uint8_t
eAvrButton_getButton()
{
    return VAR_ioFromAvr.buttons;
}

/* #[<ENTRY_PORT>]# eAvrBattery
 * entry port: eAvrBattery
 * signature:  sAvrBattery
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eAvrBattery_batteryVoltage
 * name:         eAvrBattery_batteryVoltage
 * global_name:  tAVRBody_eAvrBattery_batteryVoltage
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
uint16_t
eAvrBattery_batteryVoltage()
{
    return VAR_ioFromAvr.battery_mV;
}

/* #[<ENTRY_PORT>]# eAvrPower
 * entry port: eAvrPower
 * signature:  sAvrPower
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eAvrPower_powerDown
 * name:         eAvrPower_powerDown
 * global_name:  tAVRBody_eAvrPower_powerDown
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
powerDown()
{
    /*
     *  ٤Ƥγߤޥ롥
     */
    at91sam7s_disable_int(~0U);

    /* AVRѥ᡼򥻥å */
    VAR_ioToAvr.power = 0x5a;
    VAR_ioToAvr.pwm_frequency = 0x00;
    VAR_resetFlag = true;
    
    /* νλ */
    cTWI_pollingUpdate();

    /*
     * 1ܤǤǽ⤢Τǡ2¹Ԥ
     */
    sil_dly_nse(10*1000*1000);
    nxt_avr_updateBody();
    cTWI_pollingUpdate();
    /* AVRȤ̿1msecʾֳ֤򤢤ƹԤɬפ */
    sil_dly_nse(10*1000*1000);
    nxt_avr_updateBody();
    cTWI_pollingUpdate();

    /* AVRŸڤޤԤ */
    sil_dly_nse(1000*1000*1000);
}

void eAvrPower_powerDown() __attribute__((section(".text_ram")));

void
eAvrPower_powerDown()
{
    powerDown();
}

/* #[<ENTRY_FUNC>]# eAvrPower_update
 * name:         eAvrPower_update
 * global_name:  tAVRBody_eAvrPower_update
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void eAvrPower_update() __attribute__((section(".text_ram")));

void
eAvrPower_update()
{
    nxt_avr_updateBody();
}

/* #[<ENTRY_PORT>]# eInitialize
 * entry port: eInitialize
 * signature:  sInitializeRoutineBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eInitialize_main
 * name:         eInitialize_main
 * global_name:  tAVRBody_eInitialize_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eInitialize_main()
{
    cTWI_initialize();

    memset(&VAR_ioToAvr, 0, sizeof(VAR_ioToAvr));
    nxt_avr_link_init(); // ishikawa-add
    VAR_linkInitWait = 2;
    VAR_ioToAvr.power = 0;
    VAR_ioToAvr.pwm_frequency = 8;

    VAR_initializedFlag = true;
}

/* #[<ENTRY_PORT>]# eTerminate
 * entry port: eTerminate
 * signature:  sTerminateRoutineBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eTerminate_main
 * name:         eTerminate_main
 * global_name:  tAVRBody_eTerminate_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void eTerminate_main() __attribute__((section(".text_ram")));

void
eTerminate_main()
{
    /* AVRŸڤ */
    powerDown();
}

/* #[<ENTRY_PORT>]# eiCyclicBody
 * entry port: eiCyclicBody
 * signature:  siHandlerBody
 * context:    non-task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eiCyclicBody_main
 * name:         eiCyclicBody_main
 * global_name:  tAVRBody_eiCyclicBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void eiCyclicBody_main() __attribute__((section(".text_ram")));

void
eiCyclicBody_main()
{
    nxt_avr_updateBody();
}

/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/
