/*
 * original:lejos-osek/src/nxtvm/platform/nxt/sensor.c rev.1.1.1.1
 *          lejos-osek/src/nxtvm/platform/nxt/i2c.c rev.1.1.1.1
 * modified history.
 * 05/23/2011: Modifier Takuya Ishikawa
 * 05/24/2010: Modifier Takuya Ishikawa
 *           : Moved init_sensors from sensor.c
 *           : Moved i2c timer initialize from i2c.c
 *           : Moved i2c ISR entry from i2c.c  
 */
/*
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tSensorDriverBody_template.c => src/tSensorDriverBody.c
 * Τ褦̾, եѹƤ齤ޤ
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * °ޥ #_CAAM_#
 * portMax          uint8_t          ATTR_portMax    
 * TimerBase        uint32_t         ATTR_TimerBase  
 * interruptNumber  INTNO            ATTR_interruptNumber
 *
 * ƤӸؿ #_TCPF_#
 * call port : ciSensorDriver  signature: siSensorDriver context: task
 *   void           ciSensorDriver_initialize( subscript );
 *   void           ciSensorDriver_i2cInterruptBody( subscript, uint32_t inputs );
 *
 * #[</PREAMBLE>]# */

#include "tSensorDriverBody_tecsgen.h"
#include <sil.h>
#include "target_at91sam7s.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eInitialize
 * entry port: eInitialize
 * signature:  sInitializeRoutineBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eInitialize_main
 * name:         eInitialize_main
 * global_name:  tSensorDriverBody_eInitialize_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eInitialize_main()
{
    int8_t i;
    uint32_t setPins = ((1 << 5) | (1 << 6) | (1 << 7));

    // 󥵤ν
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_PER),  setPins);
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_PUDR), setPins);
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_OER),  setPins);
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_CODR), setPins);

    // I2Cѥޤν
    // ޤŸON
    sil_wrw_mem((void *)(TADR_PMC_BASE+TOFF_PMC_PCER), (1 << ATTR_interruptNumber));

    // ޥ쥸
    sil_wrw_mem((void *)(ATTR_TimerBase+TOFF_TC_CCR), 0x02); // disable
    sil_wrw_mem((void *)(ATTR_TimerBase+TOFF_TC_IDR), ~0);
    setPins = sil_rew_mem((void *)(ATTR_TimerBase+TOFF_TC_SR)); // dummy
    sil_wrw_mem((void *)(ATTR_TimerBase+TOFF_TC_CMR), 0x4000); // MCLK/2, RC compare trigger
    sil_wrw_mem((void *)(ATTR_TimerBase+TOFF_TC_RC), ((CLOCK_FREQUENCY/2)/(4 * 9600)));
    sil_wrw_mem((void *)(ATTR_TimerBase+TOFF_TC_IER), 0x10); // Enable RC trigger interrupt
    sil_wrw_mem((void *)(ATTR_TimerBase+TOFF_TC_CCR), 0x01); // enable

    sil_wrw_mem((void *)(ATTR_TimerBase+TOFF_TC_CCR), 0x04); // Software trigger

    for(i = 0; i < N_CP_ciSensorDriver; i++){
        ciSensorDriver_initialize(i);
    }
}

/* #[<ENTRY_PORT>]# eiBody
 * entry port: eiBody
 * signature:  siHandlerBody
 * context:    non-task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eiBody_main
 * name:         eiBody_main
 * global_name:  tSensorDriverBody_eiBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eiBody_main()
{
    int8_t i;
    uint32_t inputs;

    // ׵Υꥢ
    inputs = sil_rew_mem((void *)(ATTR_TimerBase+TOFF_TC_SR));
    // pin
    inputs = sil_rew_mem((void *)(TADR_PIO_BASE+TOFF_PIO_PDSR));

    for(i = 0; i < N_CP_ciSensorDriver; i++){
        ciSensorDriver_i2cInterruptBody(i, inputs);
    }
}

/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/
