/*
 * original:lejos-osek/src/nxtvm/platform/nxt/sensor.c rev.1.1.1.1
 * modified history.
 * 05/23/2011: Modifier Takuya Ishikawa
 * 05/25/2010: Modifier Takuya Ishikawa
 *           : Moved init_sensors to tSensorDriverBody.c
 *           : Changed digi0 to SCL, digi1 to SDA
 *           : Changed unset_digi0 to clearSCL
 *           : Changed set_digi0 to setSCL
 *           : Changed unset_digi1 to clearSDA
 *           : Changed set_digi1 to setSDA
 *           : Modified port number to component attribute
 *           : Changed interface name to entry function name with TECS naming rule
 *           : Modified some variables to component variables
 *           : Modified some constants to component attributes
 *           : Modified data type to ITRON spec.
 * 08/14/2009: Modifider Ryosuke Takeuchi
 *           : Modified Device Interface to ITRON-SIL interface and Changed
 *             AT91SAM7.h to SIL defined include file.
 *           : Modified intenal int function[] for a code size minimum.
 */
/*
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tSensorPort_template.c => src/tSensorPort.c
 * Τ褦̾, եѹƤ齤ޤ
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * °ޥ #_CAAM_#
 * portNumber       uint8_t          ATTR_portNumber 
 *
 * ƤӸؿ #_TCPF_#
 * call port : cAvrSensor  signature: sAvrSensor context: task
 *   void           cAvrSensor_setInputPower( uint8_t portNumber, uint8_t powerType );
 *   uint16_t       cAvrSensor_getSensor( uint8_t portNumber );
 *
 * #[</PREAMBLE>]# */

#include "tSensorPort_tecsgen.h"
#include <sil.h>
#include "target_at91sam7s.h"

static const uint32_t SCL[4] = { (1 << 23), (1 << 28), (1 << 29), (1 << 30) };
static const uint32_t SDA[4] = { (1 << 18), (1 << 19), (1 << 20), (1 << 2) };

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eSensorPort
 * entry port: eSensorPort
 * signature:  sSensorPort
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eSensorPort_clearSCL
 * name:         eSensorPort_clearSCL
 * global_name:  tSensorPort_eSensorPort_clearSCL
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eSensorPort_clearSCL(CELLIDX idx)
{
    CELLCB	*p_cellcb;
    if (VALID_IDX(idx)) {
        p_cellcb = GET_CELLCB(idx);
    }

    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_PER), SCL[ATTR_portNumber]);
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_OER), SCL[ATTR_portNumber]);
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_CODR), SCL[ATTR_portNumber]);
}

/* #[<ENTRY_FUNC>]# eSensorPort_clearSDA
 * name:         eSensorPort_clearSDA
 * global_name:  tSensorPort_eSensorPort_clearSDA
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eSensorPort_clearSDA(CELLIDX idx)
{
    CELLCB	*p_cellcb;
    if (VALID_IDX(idx)) {
        p_cellcb = GET_CELLCB(idx);
    }

    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_PER), SDA[ATTR_portNumber]);
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_OER), SDA[ATTR_portNumber]);
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_CODR), SDA[ATTR_portNumber]);
}

/* #[<ENTRY_FUNC>]# eSensorPort_setSCL
 * name:         eSensorPort_setSCL
 * global_name:  tSensorPort_eSensorPort_setSCL
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eSensorPort_setSCL(CELLIDX idx)
{
    CELLCB	*p_cellcb;
    if (VALID_IDX(idx)) {
        p_cellcb = GET_CELLCB(idx);
    }

    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_PER), SCL[ATTR_portNumber]);
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_OER), SCL[ATTR_portNumber]);
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_SODR), SCL[ATTR_portNumber]);
}

/* #[<ENTRY_FUNC>]# eSensorPort_setSDA
 * name:         eSensorPort_setSDA
 * global_name:  tSensorPort_eSensorPort_setSDA
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eSensorPort_setSDA(CELLIDX idx)
{
    CELLCB	*p_cellcb;
    if (VALID_IDX(idx)) {
        p_cellcb = GET_CELLCB(idx);
    }

    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_PER), SDA[ATTR_portNumber]);
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_OER), SDA[ATTR_portNumber]);
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_SODR), SDA[ATTR_portNumber]);
}

/* #[<ENTRY_FUNC>]# eSensorPort_inputPower
 * name:         eSensorPort_inputPower
 * global_name:  tSensorPort_eSensorPort_inputPower
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eSensorPort_inputPower(CELLIDX idx, uint8_t powerType)
{
    CELLCB	*p_cellcb;
    if (VALID_IDX(idx)) {
        p_cellcb = GET_CELLCB(idx);
    }

    cAvrSensor_setInputPower(ATTR_portNumber, powerType);
}

/* #[<ENTRY_FUNC>]# eSensorPort_getValue
 * name:         eSensorPort_getValue
 * global_name:  tSensorPort_eSensorPort_getValue
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
uint16_t
eSensorPort_getValue(CELLIDX idx)
{
    CELLCB	*p_cellcb;
    if (VALID_IDX(idx)) {
        p_cellcb = GET_CELLCB(idx);
    }

    return cAvrSensor_getSensor(ATTR_portNumber);
}

/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/
