/*
 * original:lejos-osek/src/nxtvm/platform/nxt/sound.c rev.1.1.1.1
 * modified history.
 * 05/24/2012: Modifier Takuya Ishikawa
 *           : cast void*
 * 05/23/2011: Modifier Takuya Ishikawa
 * 05/24/2010: Modifier Takuya Ishikawa
 *           : Modified sound_freq to beepTone which is the entry function of eSound
 *           : Modified sound_init to main which is the entry function of eInitialize
 *           : Modified sound_isr_C to main which is the entry function of eiBody
 *           : Modified some constants to component attributes
 *           : Modified some variables to component variables
 *           : Modified local function name for TECS naming rule
 * 04/16/2010: Modifider Ryosuke Takeuchi
 *           : Modified Device Interface to ITRON-SIL interface and Changed
 *             AT91SAM7.h to SIL defined include file.
 *           : Modified sound_init for ITRON interrupt system.
 */
/*
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tSoundBody_template.c => src/tSoundBody.c
 * Τ褦̾, եѹƤ齤ޤ
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * °ޥ #_CAAM_#
 * maxTonePattern   const uint32_t*  ATTR_maxTonePattern
 * toneCycles       uint32_t         VAR_toneCycles  
 * tonePattern      uint32_t*        VAR_tonePattern 
 * volume           int8_t           VAR_volume      
 *
 * #[</PREAMBLE>]# */

#include "tSoundBody_tecsgen.h"
#include "target_at91sam7s.h"
#include <sil.h>

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

static inline void
soundEnableInt()
{
    sil_wrw_mem((void *)(TADR_SSC_BASE+TOFF_SSC_IER), SSC_ENDTX);
}

static inline void
soundDisableInt()
{
    sil_wrw_mem((void *)(TADR_SSC_BASE+TOFF_SSC_IDR), SSC_ENDTX);
}

static inline void
soundEnable()
{
    // PIOȥ餫λѤػߤ
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_PDR), (1 << 17));
}

static inline void
soundDisable()
{
    // PIOȥ餫λѤĤ
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_PER), (1 << 17));
}


/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eSound
 * entry port: eSound
 * signature:  sSound
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eSound_beepTone
 * name:         eSound_beepTone
 * global_name:  tSoundBody_eSound_beepTone
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eSound_beepTone(uint32_t frequency, uint32_t msecond)
{
    int8_t i;

    if(VAR_volume != 0){

        sil_wrw_mem((void *)(TADR_SSC_BASE+TOFF_SSC_CMR), ((96109714 / 1024) / frequency) + 1);
        sil_wrw_mem((void *)(TADR_SSC_BASE+TOFF_SSC_PTCR), PDC_TXTEN);
        VAR_toneCycles = (frequency * msecond) / 2000 - 1;

        for(i = 0; i < 16; i++){
            VAR_tonePattern[i] = ATTR_maxTonePattern[i] >> (32 - (32 * VAR_volume / 100));
        }

        soundEnableInt();
    }
}

/* #[<ENTRY_FUNC>]# eSound_setVolume
 * name:         eSound_setVolume
 * global_name:  tSoundBody_eSound_setVolume
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eSound_setVolume(uint8_t volume)
{
    VAR_volume = volume;
}

/* #[<ENTRY_PORT>]# eInitialize
 * entry port: eInitialize
 * signature:  sInitializeRoutineBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eInitialize_main
 * name:         eInitialize_main
 * global_name:  tSoundBody_eInitialize_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eInitialize_main()
{
    soundDisableInt();
    soundDisable();

    sil_wrw_mem((void *)(TADR_PMC_BASE+TOFF_PMC_PCER), (1 << INTNO_SSC_PID));

    sil_wrw_mem((void *)(TADR_SSC_BASE+TOFF_SSC_CR),   SSC_SWRST);
    sil_wrw_mem((void *)(TADR_SSC_BASE+TOFF_SSC_TCMR), (SSC_CKS_DIV + SSC_CKO_CONTINOUS + SSC_START_CONTINOUS));
    sil_wrw_mem((void *)(TADR_SSC_BASE+TOFF_SSC_TFMR), (31 + (7 << 8) + SSC_MSBF));
    sil_wrw_mem((void *)(TADR_SSC_BASE+TOFF_SSC_CR),   SSC_TXEN);
    sil_wrw_mem((void *)(TADR_AIC_BASE+TOFF_AIC_ICCR), (1 << INTNO_SSC_PID)); // add
}

/* #[<ENTRY_PORT>]# eiBody
 * entry port: eiBody
 * signature:  siHandlerBody
 * context:    non-task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eiBody_main
 * name:         eiBody_main
 * global_name:  tSoundBody_eiBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eiBody_main()
{
    if(VAR_toneCycles--){
        sil_wrw_mem((void *)(TADR_SSC_BASE+TOFF_SSC_TNPR), (uint32_t)VAR_tonePattern);
        sil_wrw_mem((void *)(TADR_SSC_BASE+TOFF_SSC_TNCR), 16);
        soundEnable();

    } else {
        soundDisable();
        soundDisableInt();
    }
}

/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/
